# same(鮫)

## 概要

コマンドラインで使うゴミ箱です。

間違ってファイルを消してしまうことを防止するため，
一時的にゴミ箱ディレクトリ「$HOME/.same」にファイルを保存します。

ゴミ箱がいっぱいになると，古いものから順に完全に削除するので，
ゴミ箱の中を掃除したり，ゴミ箱の中を空にする必要がないのが特徴です。

実行例
sh> ls *.txt
a.txt b.txt c.txt
sh> same b.txt c.txt
...（b.txtとc.txtの情報が表示）
(max=100) eat?> y
sh> ls *.txt
a.txt
sh> same -l
...（過去に削除したファイルの一覧が表示）
sh> same -r 012（復元するファイルの番号）
...（復元するファイルの情報が表示）
restore?> y
...（b.txtとc.txtを復元）
sh> ls *.txt
a.txt b.txt c.txt

## 著作権

Copyright © 2017-2022 Seiichiro HATA

## 連絡先

<infotech@hata-o.jp>

ご要望やバグ情報のご連絡には，速やかに対応するように努めておりますが，
多忙のため，全てのメールにお返事はいたしかねますので，ご了承ください。

## ウェブページ

<http://hata-o.jp/kian/?tools>

## 動作環境

UNIX系の環境であれば，たぶん動くと思います。

## インストール方法

このディレクトリ内の「same」を，
パスの通っているディレクトリ（「/usr/local/bin/」等）にコピーし，
適切な実行権限を確認してください。

## アンインストール方法

コピーした「same」を削除してください。

必要があれば，ホームディレクトリ内の「.same」を削除してください。

## 使用方法

ファイル（ディレクトリを含む。）をゴミ箱に移します。
> same <files>

ゴミ箱内のファイル（ディレクトリを含む。）の一覧を表示します。
> same -l

ゴミ箱内のファイル（ディレクトリを含む。）を元に戻します。
> same -r <number>

ファイル（ディレクトリを含む。）を完全に削除します。
> same -k <files>

ゴミ箱の容量（保存する回数）を設定します。
> same -m <number>

ゴミ箱の「ゴミ捨て中」を解除します。
> same -c

## ライセンス

GNU General Public Licenseバージョン3 (GPLv3)又はその後継バージョン

GPLv3のライセンス条項は，LICENSE-GPLv3.txtをご覧ください。

## 免責条項

ライセンスに定められているとおり，本プログラムにより損害が発生したとしても，
著作権者は何らの損害賠償責任も負いませんので，ご注意ください。

## 問題点

要望があれば，GUIにも対応したいと思っています。

## 開発動機

「ゴミ箱の中のゴミ（ファイル）は，自動で処分して欲しい。」
これが，本ソフトの開発動機です。

通常のゴミ箱ソフトは，定期的に，ユーザーがゴミ箱の中を見て，
本当に不要なファイルを処分する前提で作られています。
もっとも，ゴミ箱の中のファイルを見たとき，何のファイルか思い出せなかったり，
不要なファイルだと思いながらも，完全に削除する決心がつかなかったりするなど，
このような作業は負担が大きいものです。

本ソフトは，ゴミ箱がいっぱいになると，古いものから自動で処分するため，
何のファイルか思い出したり，完全に削除する決心をつけたりすることは不要です。

本ソフトは歴史が深く，一番最初のバージョンは，
PC-98にインストールしたFreeBSD上で開発しました。

## ヒストリー

### 2022.08.13 v17 リリース

補完するファイルのサイズを記録するようにしました。

コードを整理しました。

### 2020.08.17 v16 リリース

コードを整理しました。

### 2019.07.31 v15 リリース

バグを修正しました。

### 2019.01.29 v14 リリース

rootディレクトリーを削除できないようにしました。

homeディレクトリーを削除できないようにしました。

currentディレクトリーを削除できないようにしました。

parentディレクトリーを削除できないようにしました。

### 2019.01.03 v13 リリース

POSIXに準拠しました。

ls（GNU coreutils）の仕様変更に対応しました。

### 2017.06.24 v12 リリース

echoをprintfに書き換えました。

### 2017.06.17 v11 リリース

最初の公開になります。
